<template>
  <div class="container">
    <div class="row justify-content-center ">

      <div class="col-md-12">
        <div v-if="message" class="alert bg-success text-white m-4">
          <p>{{ message }}</p>
        </div>
      </div>

      <div class="col-md-12">
        <div class="card card-default">
          <div class="card-header container-fluid">

            <div class="row">
              <div class="col-md-10">
                <h3 class="w-75 p-3">Data {{title}}</h3>
              </div>
              <div class="col-md-2 float-right">
                <router-link :to="{name: 'add-user', params: { userType: this.type, userRole: this.title}}" class="btn btn-success">Tambah {{title}}</router-link>
              </div>
            </div>

          </div>

          <div class="card-body">
            
            <table class="table table-bordered">
              <thead>
                <tr>
                    <th>No.</th>
                    <th>Nama</th>
                    <th>Email</th>
                    <th>Created At</th>
                    <th>Action</th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="(u, i) in users" :key="u.id">
                    <td>{{ i+1 }}</td>
                    <td>{{ u.name }}</td>
                    <td>{{ u.email }}</td>
                    <td>{{ u.created_at }}</td>
                    <td>
                      <button class="btn btn-danger" @click="deleteUser(u.id)">Hapus</button>
                    </td>
                </tr>
              </tbody>
            </table>
            
          </div>
        </div>
      </div>
    </div>
    
  </div>
</template>
<script>
  export default {
      data(){
          return {
              title : '',
              type: 1,
              users: [],
              message: null,
          }
      },
      watch: {
        '$route.params.userRole': function (userRole) {
          this.doStuff()
        }
      },
      beforeMount(){ 
         this.doStuff()
      },
      methods: {
        doStuff() {
            axios.defaults.headers.common['Content-Type'] = 'application/json'
            axios.defaults.headers.common['Authorization'] = 'Bearer ' + localStorage.getItem('jwt')
            
            this.title = this.$route.params.userRole
            this.type = this.$route.params.userType
            this.message = this.$route.params.message
    
            axios.get(`../api/users/${this.type}`)
            .then(response => { 
                this.users = response.data.data
            })
            .catch(error => {
                console.error(error);
            }) 
        },
        deleteUser(id) {
          this.$swal.fire({
            title: 'Apakah kamu yakin?',
            text: "Data tidak dapat dikembalikan setelah dihapus!",
            icon: 'warning',
            showCancelButton: true,
            cancelButtonColor: '#d33',
            confirmButtonText: 'Hapus!'
          }).then((result) => {
            if (result.isConfirmed) {

              axios.defaults.headers.common['Content-Type'] = 'application/json'
              axios.defaults.headers.common['Authorization'] = 'Bearer ' + localStorage.getItem('jwt')
              
              axios.get(`../api/users-delete/${id}`)
                .then(response => { 
                    this.$swal.fire({
                      icon: 'success',
                      title: response.data.message,
                      showConfirmButton: false,
                    })

                    this.doStuff()
                })
                .catch(error => {
                    console.error(error);
                }) 
            }
          })
        }
      }
  }
</script>